{ lib, nimPackages, fetchgit }:
with nimPackages;

let
  bigints = fetchNimble {
    pname = "bigints";
    version = "0.5.0";
    hash = "sha256-zMTXXC0lYVzXaKl8eC/SA/CymRgovgzxBdvEn1VE9p0=";
  };

  compiler = fetchNimble {
    pname = "compiler";
    version = "1.4.8";
    hash = "sha256-OaSe9Bn/+rjVk4pJKjjwI9rpnDm/T7lRmKeh/DOPn38=";
  };

  npeg = fetchNimble {
    pname = "npeg";
    version = "0.24.1";
    hash = "sha256-AKYDrR38345CQxV7kLvglGmkc/m8EX6TGtaFckJL3Dc=";
  };

in buildNimPackage rec {
  outputs = [ "out" "dev" ];
  pname = "preserves";
  version = "1.0.0";
  src = fetchgit {
    url = "https://git.sr.ht/~ehmry/preserves-nim";
    rev = "v${version}";
    sha256 = "18702q7vmyf5kkgn9nqf96kcar5pqxisf03ybrqw3hfp95vxixn4";
  };
  buildInputs = [ compiler bigints npeg ];
}
